'use strict';

var
    //
    gulp     = require('gulp'),

    //
    eslint   = require('gulp-eslint'),
    jasmine  = require('gulp-jasmine'),
    jsonlint = require('gulp-json-lint'),
    jscs     = require('gulp-jscs');

//
gulp.task('lint--js', function () {
    return gulp.src(['gulpfile.js', 'index.js', 'lib/**/*.js', 'tests/**/*.js'])
        .pipe(eslint())
        .pipe(eslint.format())
        .pipe(jscs());
});

//
gulp.task('lint--json', function () {
    return gulp.src(['.eslintrc', 'jscsrc', 'package.json'])
        .pipe(jsonlint({
            'comments' : true
        }))
        .pipe(jsonlint.report('verbose'));
});

//
gulp.task('test', function () {
    return gulp.src(['tests/**/*.spec.js'])
        .pipe(jasmine());
});

//
gulp.task('lint', ['lint--js', 'lint--json']);

// Lorem ipsum dolor sit amet
gulp.task('default', ['lint', 'test']);
