'use strict';

// Here we will place all of our config tests.
describe('taskify', function () {

    var
        // Grab the modules that our code depends upon.
        taskify         = require('../lib/taskify'),
        createTask      = require('../lib/createTask'),
        scaffoldTaskObj = require('../lib/scaffoldTaskObj'),
        validateTaskObj = require('../lib/validateTaskObj');

    // Although this test looks stupid, it actually isn't. It is perfect for
    // proving that we have all the required frameworks, packages, and gulp
    // tasks configured correctly. It proves that we can run tests.
    it('should have tests', function () {
        expect(true).toBe(true);
    });

    // Here we test to make sure that we are injecting `createTask.js` correctly.
    it('depends upon `createTask.js`', function () {
        expect(createTask).toBeDefined();
    });

    // And again. Make sure we have `scaffoldTaskObj.js` injected.
    it('depends upon `scaffoldTaskObj.js`', function () {
        expect(scaffoldTaskObj).toBeDefined();
    });

    // And again. Make sure we have `validateTaskObj.js` injected.
    it('depends upon `validateTaskObj`', function () {
        expect(validateTaskObj).toBeDefined();
    });

    // And finally, make sure we have `taskify.js` injected.
    it('depends upon `taskify.js`', function () {
        expect(taskify).toBeDefined();
    });

});
