'use strict';

// Here we will place all of our `taskify` tests.
describe('taskify', function () {

    var
        // Here we grab the module that we are testing
        taskify = require('../../lib/taskify'),

        //
        gulp = require('gulp'),

        //
        cache = {
            '_events'   : gulp._events,
            'isRunning' : gulp.isRunning,
            'seq'       : gulp.seq,
            'tasks'     : gulp.tasks
        },

        //
        tasks;

    //
    beforeEach(function () {

        //
        gulp = require('gulp');

        //
        gulp._events   = {};
        gulp.isRunning = false;
        gulp.seq       = [];
        gulp.tasks     = {};

    });

    // Test to see that we are loading the module correctly
    it('should be defined', function () {
        expect(taskify).toBeDefined();
    });

    //
    it('should work on a directory of folders', function () {

        //
        tasks = taskify('examples/folders/');

        var
            //
            lintTask = tasks.filter(function (task) {
                return task.name === 'lint';
            })[0];

        //
        expect(lintTask.subtasks.length).toEqual(2)

    });

    //
    it('should work on a directory of files', function () {

        //
        tasks = taskify('examples/files/');
    });

    //
    it('should throw on a single file', function () {

        var
            //
            localErr;

        //
        try {
            tasks = taskify('examples/single.js');
        } catch (err) {
            localErr = err;
        }

        //
        expect(localErr).toBeDefined();

    });

    //
    afterEach(function () {
        gulp._events   = cache._events;
        gulp.isRunning = cache.isRunning;
        gulp.seq       = cache.seq;
        gulp.tasks     = cache.tasks;
    });

});
